/*
Created by: X
http://www.createdbyx.com/

xGameConsoleXNA is licenced under the Creative Commons Attribution-NonCommercial-ShareAlike 2.5 Canada
http://creativecommons.org/licenses/by-nc-sa/2.5/ca/
*/
using System.Diagnostics;
//using System.Data;
using System.Collections;
using System.Collections.Generic;
using System;

namespace xGameConsoleXNA
{
	namespace GenericCommands
	{
       public abstract class BaseCommands : ICommandExtender, IDisposable
		{
			
			
			// Protected Friend WithEvents CommandEvents As CommandManager
			protected internal CommandManager mobjManager;
			protected internal CommandExtenderManager mobjExtenderManager;
			protected internal bool mblnIsConnected = false;
			protected internal System.Collections.Specialized.StringCollection mobjCommandList;
			protected internal bool mblnRemovingCommands = false;
			protected internal Console mobjConsoleReference;
			
			
			public CommandExtenderManager CommandExtenderManager
			{
				get
				{
					return mobjExtenderManager;
				}
			}
			
			public CommandManager CommandManager
			{
				get
				{
					return mobjManager;
				}
			}
			
			public xGameConsoleXNA.Console ConsoleReference
			{
				get
				{
					return mobjConsoleReference;
				}
				set
				{
					mobjConsoleReference = value;
				}
			}
			
			protected virtual void CommandEvents_CommandExecuted(object Sender, ReturnValueEventArgs e)
			{
				//If disposed Then Exit Sub
				//If mblnIsConnected = False Then Exit Sub
				
				//If mstrFile = String.Empty Then Exit Sub
				
				//Dim F As IO.StreamWriter
				//F = New IO.StreamWriter(mstrFile, True)
				//F.WriteLine(CommandName & " " & String.Join(" ", Args))
				//F.Flush()
				//F.Close()
				//F = Nothing
			}
			
			protected internal void DoAddCommand(string Name, CommandCallback CB)
			{
				if (disposed)
				{
					return;
				}
				if (mobjManager == null)
				{
					return;
				}
				if (mobjExtenderManager.CommandManager == null)
				{
					return;
				}
				// If mobjExtenderManager.CommandManager.CommandManager Is Nothing Then Exit Sub
				mobjManager.AddCommand(Name, CB);
				mobjCommandList.Add(Name);
			}
			
			internal void CommandIsBeingRemoved(string CommandName, System.ComponentModel.CancelEventArgs e)
			{
				if (disposed)
				{
					return;
				}
				// we can now prevent any of our commands from being removed
				e.Cancel = (mobjCommandList.IndexOf(CommandName) != - 1) &&(mblnRemovingCommands == false);
				if (e.Cancel)
				{
					if (mblnIsConnected == false)
					{
						return;
					}
					if (mobjExtenderManager.CommandManager == null)
					{
						return;
					}
					this.Print("Some process tried to remove command " + CommandName);
				}
			}
			
			internal void DoRemoveCommands()
			{
				if (disposed)
				{
					return;
				}
				if (mobjManager == null)
				{
					return;
				}
				if (mobjExtenderManager.CommandManager == null)
				{
					return;
				}
				// If mobjExtenderManager.CommandManager.CommandManager Is Nothing Then Exit Sub
				mblnRemovingCommands = true;
				string tmp;
				foreach (string tempLoopVar_tmp in mobjCommandList)
				{
					tmp = tempLoopVar_tmp;
					mobjManager.RemoveCommand(tmp);
				}
				mobjCommandList.Clear();
				mblnRemovingCommands = false;
			}
			
			public void PrintBlankLine()
			{
				mobjConsoleReference.PrintBlankLine();
			}
			
			public void Print(string Text)
			{
				mobjConsoleReference.Print(Text);
			}
			
			public void Print(string[] Text)
			{
				mobjConsoleReference.Print(Text);
			}
			
			public void Print(System.Collections.Specialized.StringCollection Text)
			{
				mobjConsoleReference.Print(Text);
			}
			
			public virtual bool IsConnected
			{
				get
				{
					return mblnIsConnected;
				}
			}
			
			public virtual void OnConnect(CommandManager Manager, CommandExtenderManager ExtenderManager)
			{
				if (disposed)
				{
					return;
				}
				mobjManager = Manager;
				mobjManager.AfterCommandExecuted += new xGameConsoleXNA.CommandManager.AfterCommandExecutedEventHandler(CommandEvents_CommandExecuted);
				mobjExtenderManager = ExtenderManager;
				if (mobjManager == null)
				{
					return;
				}
				if (mobjExtenderManager.CommandManager == null)
				{
					return;
				}
				//  If mobjExtenderManager.CommandManager.CommandManager Is Nothing Then Exit Sub
				mobjCommandList = new System.Collections.Specialized.StringCollection();
				//DoAddCommand("logcommandsfile", AddressOf RecordCommandsFile)
				//DoAddCommand("logcommands", AddressOf RecordCommands)
				//DoAddCommand("stoplogcommands", AddressOf StopRecordCommands)
				mobjManager.BeforeRemoveCommand += new xGameConsoleXNA.CommandManager.BeforeRemoveCommandEventHandler(CommandIsBeingRemoved);
				mblnIsConnected = true;
			}
			
			public virtual void OnDisconnect()
			{
				if (disposed)
				{
					return;
				}
				if (mblnIsConnected == false)
				{
					return;
				}
				mblnIsConnected = false;
				mobjCommandList.Clear();
				mobjCommandList = null;
				mobjManager.BeforeRemoveCommand -= new xGameConsoleXNA.CommandManager.BeforeRemoveCommandEventHandler(CommandIsBeingRemoved);
				mobjManager = null;
				mobjManager.AfterCommandExecuted += new xGameConsoleXNA.CommandManager.AfterCommandExecutedEventHandler(CommandEvents_CommandExecuted);
				DoRemoveCommands();
			}
			
			
			#region " IDisposable Support "
			private bool disposed = false;
			// IDisposable
			private void Dispose(bool disposing)
			{
				if (! this.disposed)
				{
					if (disposing)
					{
						DoRemoveCommands();
						if (mobjCommandList != null)
						{
							mobjCommandList.Clear();
						}
						mobjCommandList = null;
						if (mobjManager != null)
						{
							//If mobjExtenderManager.CommandManager IsNot Nothing Then
							// If mobjExtenderManager.CommandManager.CommandManager Is Nothing = False Then
							mobjManager.BeforeRemoveCommand -= new xGameConsoleXNA.CommandManager.BeforeRemoveCommandEventHandler(CommandIsBeingRemoved);
							//End If
							//End If
						}
						mobjManager = null;
						mobjManager.AfterCommandExecuted += new xGameConsoleXNA.CommandManager.AfterCommandExecutedEventHandler(CommandEvents_CommandExecuted);
					}
					// put code to free unmanaged resources here
				}
				this.disposed = true;
			}
			
			// This code added by Visual Basic to correctly implement the disposable pattern.
			public virtual void Dispose()
			{
				// Do not change this code.  Put cleanup code in Dispose(ByVal disposing As Boolean) above.
				Dispose(true);
				GC.SuppressFinalize(this);
			}
			
			~BaseCommands()
			{
				// Do not change this code.  Put cleanup code in Dispose(ByVal disposing As Boolean) above.
				Dispose(false);
               // ~base();
			}
			#endregion
			
			  
			
			public BaseCommands()
			{
				
			}
			
			public BaseCommands(xGameConsoleXNA.Console Console) : this()
			{
				this.mobjConsoleReference = Console;
			}
		}
	}
}
