/*
Created by: X
http://www.createdbyx.com/

xGameConsoleXNA is licenced under the Creative Commons Attribution-NonCommercial-ShareAlike 2.5 Canada
http://creativecommons.org/licenses/by-nc-sa/2.5/ca/
*/
using System.Diagnostics;
//using System.Data;
using System.Collections;
using System.Collections.Generic;
using System;
using System.ComponentModel;

namespace xGameConsoleXNA
{
	namespace GenericCommands
	{
		
		public class CommandLogger : BaseCommands
		{
			
			private const string STR_RecordCommands = "Begins recording commands typed into the console." + "\r\n" + "Use /d or /delete to delete any existing log file." + "\r\n" + "Will return False if existing log file could not be deleted and logging will not occour.";
			protected internal string mstrStartloggingcommands = "startloggingcommands";
			
			protected internal string mstrLogcommandsfile = "setlogfile";
			
			private bool mblnLogging = false;
			private string mstrFile = string.Empty;
			
			public CommandLogger()
			{
			}
			
			public CommandLogger(xGameConsoleXNA.Console Console) : base(Console)
			{
			}
			
			protected override void CommandEvents_CommandExecuted(object Sender, ReturnValueEventArgs e)
			{
				if (mblnIsConnected == false)
				{
					return;
				}
				if (mstrFile == string.Empty)
				{
					return;
				}
				
				string Tmp = string.Empty;
				string Cmd = e.Command;
				if (mobjManager.IgnoreCase )
				{
					Cmd = e.Command.ToLower();
				}
				
				Tmp = string.Join(" ", e.Args);
				if (Cmd == mstrStartloggingcommands && Tmp == mstrFile)
				{
					return;
				}
				
				
				System.IO.StreamWriter F;
				F = new System.IO.StreamWriter(mstrFile, true);
				F.WriteLine(e.Command + " " + Tmp);
				F.Flush();
				F.Close();
				F = null;
			}
			
			[Category("Logging"), Description("Sets the file that the recorded commands will be saved to.")]internal string RecordCommandsFile(string[] Args)
			{
				if (mblnIsConnected == false)
				{
					return string.Empty;
				}
				// If mblnLogging = False Then Return String.Empty
				if (Args == null)
				{
					return mstrFile;
				}
				Args = mobjManager.ProcessArguments(Args);
				
				string Tmp;
				Tmp = string.Join(" ", Args);
				string Dir = System.IO.Path.GetDirectoryName(Tmp);
				if (Dir != string.Empty)
				{
					if (System.IO.Directory.Exists(Dir))
					{
						mstrFile = Tmp;
					}
					else
					{
						this.Print("Directory does not appear to exist. " + Dir);
					}
				}
				else
				{
					mstrFile = Tmp;
				}
				return mstrFile;
			}
			
			[Category("Logging"), Description(STR_RecordCommands)]internal string RecordCommands(string[] Args)
			{
				if (mblnIsConnected == false)
				{
					return false.ToString();
				}
				if (mstrFile == string.Empty)
				{
					return false.ToString();
				}
				if (Args != null)
				{
					Args = mobjManager.ProcessArguments(Args);
					if (Args.Length == 1)
					{
						if (Args[0].ToLower() == "/d" || Args[0].ToLower() == "/delete")
						{
							if (System.IO.File.Exists(mstrFile))
							{
								try
								{
									System.IO.File.Delete(mstrFile);
								}
								catch
								{
									return false.ToString();
								}
							}
						}
						
					}
					else if (Args.Length > 1)
					{
						this.Print(STR_RecordCommands);
					}
				}
				mblnLogging = true;
				return mblnLogging.ToString();
			}
			
			[Category("Logging"), Description("Stops recording commands typed into the console.")]internal string StopRecordCommands(string[] Args)
			{
				//If mblnIsConnected = False Then Exit Sub
				mblnLogging = false;
				return true.ToString();
			}
			
			//Private Sub DoAddCommand(ByVal Name As String, ByVal CB As DXTools.CommandCallback)
			//    If mobjManager Is Nothing Then Exit Sub
			//    If mobjManager.Console Is Nothing Then Exit Sub
			//    If mobjManager.Console.CommandManager Is Nothing Then Exit Sub
			//    mobjManager.Console.CommandManager.AddCommand(Name, CB)
			//    mobjCommandList.Add(Name)
			//End Sub
			
			//Private Sub CommandIsBeingRemoved(ByVal CommandName As String, ByVal e As System.ComponentModel.CancelEventArgs)
			//    ' we can now prevent any of our commands from being removed
			//    e.Cancel = (mobjCommandList.IndexOf(CommandName) <> -1) And (mblnRemovingCommands = False)
			//    If e.Cancel Then
			//        If mblnIsConnected = False Then Exit Sub
			//        If mobjManager.Console Is Nothing Then Exit Sub
			//        mobjManager.Console.Print("CommandLogger: Some process tried to remove command " & CommandName)
			//    End If
			//End Sub
			
			//Private Sub DoRemoveCommands()
			//    If mobjManager Is Nothing Then Exit Sub
			//    If mobjManager.Console Is Nothing Then Exit Sub
			//    If mobjManager.Console.CommandManager Is Nothing Then Exit Sub
			//    mblnRemovingCommands = True
			//    Dim tmp As String
			//    For Each tmp In mobjCommandList
			//        mobjManager.Console.CommandManager.RemoveCommand(tmp)
			//    Next
			//    mobjCommandList.Clear()
			//    mblnRemovingCommands = False
			//End Sub
			
			//Public ReadOnly Property IsConnected() As Boolean Implements DXTools.IConsoleExtender.IsConnected
			//    Get
			//        Return mblnIsConnected
			//    End Get
			//End Property
			
			public override void OnConnect(CommandManager Manager, CommandExtenderManager ExtenderManager)
			{
				base.OnConnect(Manager, ExtenderManager);
				if (mobjManager == null)
				{
					return;
				}
				//mobjManager = Manager
				//If mobjManager Is Nothing Then Exit Sub
				//If mobjManager.Console Is Nothing Then Exit Sub
				//If mobjManager.Console.CommandManager Is Nothing Then Exit Sub
				//mobjCommandList = New Collections.Specialized.StringCollection()
				//AddHandler mobjManager.Console.CommandManager.BeforeRemoveCommand, AddressOf CommandIsBeingRemoved
				//mblnIsConnected = True
				DoAddCommand(mstrLogcommandsfile, new xGameConsoleXNA.CommandCallback( RecordCommandsFile));
				DoAddCommand(mstrStartloggingcommands, new xGameConsoleXNA.CommandCallback( RecordCommands));
				DoAddCommand("stoploggingcommands", new xGameConsoleXNA.CommandCallback( StopRecordCommands));
			}
			
			//    Public Sub OnDisconnect() Implements DXTools.IConsoleExtender.OnDisconnect
			//        mblnIsConnected = False
			//        mobjCommandList.Clear()
			//        mobjCommandList = Nothing
			//        mobjManager = Nothing
			//        RemoveHandler mobjManager.Console.CommandManager.BeforeRemoveCommand, AddressOf CommandIsBeingRemoved
			//    End Sub
			
			
			//#Region " IDisposable Support "
			//    Private disposed As Boolean = False
			//    ' IDisposable
			//    Private Overloads Sub Dispose(ByVal disposing As Boolean)
			//        If Not Me.disposed Then
			//            If disposing Then
			//                DoRemoveCommands()
			//                If mobjCommandList Is Nothing = False Then
			//                    mobjCommandList.Clear()
			//                End If
			//                mobjCommandList = Nothing
			//                If mobjManager Is Nothing = False Then
			//                    If mobjManager.Console Is Nothing = False Then
			//                        If mobjManager.Console.CommandManager Is Nothing = False Then
			//                            RemoveHandler mobjManager.Console.CommandManager.BeforeRemoveCommand, AddressOf CommandIsBeingRemoved
			//                        End If
			//                    End If
			//                End If
			//                mobjManager = Nothing
			
			//            End If
			//            ' TODO: put code to free unmanaged resources here
			//        End If
			//        Me.disposed = True
			//    End Sub
			
			//    ' This code added by Visual Basic to correctly implement the disposable pattern.
			//    Public Overloads Sub Dispose() Implements IDisposable.Dispose
			//        ' Do not change this code.  Put cleanup code in Dispose(ByVal disposing As Boolean) above.
			//        Dispose(True)
			//        GC.SuppressFinalize(Me)
			//    End Sub
			
			//    Protected Overrides Sub Finalize()
			//        ' Do not change this code.  Put cleanup code in Dispose(ByVal disposing As Boolean) above.
			//        Dispose(False)
			//        MyBase.Finalize()
			//    End Sub
			//#End Region
		}
	}
	
}
