/*
Created by: X
http://www.createdbyx.com/

xGameConsoleXNA is licenced under the Creative Commons Attribution-NonCommercial-ShareAlike 2.5 Canada
http://creativecommons.org/licenses/by-nc-sa/2.5/ca/
*/
using System.Diagnostics;
//using System.Data;
using System.Collections;
using System.Collections.Generic;
using System;
using System.ComponentModel;


namespace xGameConsoleXNA
{
	namespace GenericCommands
	{
		
		public class LogicCommands : BaseCommands
		{
			
			// Implements DXTools.IConsoleExtender, idisposable
			
			private System.Collections.Generic.Dictionary<string, string> mobjVaribles = new System.Collections.Generic.Dictionary<string, string>();
			
			#region " Commands ... "
			[Category("Logic"), Description("If the first argument evaluates to true this command will execute the specified command.")]private string IfTrueCommand(string[] Args)
			{
				Args = mobjManager.ProcessArguments(Args);
				if (Args.Length < 3)
				{
					return null;
				}
				if (Args[1].Trim().ToLower() != "then")
				{
					return null;
				}
				
				if (System.Convert.ToBoolean(Args[0]))
				{
					return mobjManager.Execute(Helpers.StringArrayToString(Args, 2, ' '), null);
				}
				
				return null;
			}
			
			[Category("Logic"), Description("If the first argument evaluates to false this command will execute the specified command.")]private string IfFalseCommand(string[] Args)
			{
				Args = mobjManager.ProcessArguments(Args);
				if (Args.Length < 3)
				{
					return null;
				}
				if (Args[1].Trim().ToLower() != "then")
				{
					return null;
				}
				
				if (System.Convert.ToBoolean(Args[0]) == false)
				{
					return mobjManager.Execute(Helpers.StringArrayToString(Args, 2, ' '), null);
				}
				
				return null;
			}
			
			[Category("Logic"), Description("Compars two values and returns true or false.")]private string EqualsCommand(string[] Args)
			{
				Args = mobjManager.ProcessArguments(Args);
				if (Args.Length < 2)
				{
					return bool.FalseString;
				}
				
				if (Args[0] == Args[1])
				{
					return bool.TrueString;
				}
				else
				{
					return bool.FalseString;
				}
			}
			
			#endregion
			
			public LogicCommands()
			{
			}
			
			public LogicCommands(xGameConsoleXNA.Console Console) : base(Console)
			{
			}
			
			public override void OnConnect(CommandManager Manager, CommandExtenderManager ExtenderManager)
			{
				base.OnConnect(Manager, ExtenderManager);
				DoAddCommand("iftrue", new xGameConsoleXNA.CommandCallback( this.IfTrueCommand));
				DoAddCommand("iffalse", new xGameConsoleXNA.CommandCallback( this.IfFalseCommand));
				DoAddCommand("equals", new xGameConsoleXNA.CommandCallback( this.EqualsCommand));
			}
		}
	}
}
