/*
Created by: X
http://www.createdbyx.com/

xGameConsoleXNA is licenced under the Creative Commons Attribution-NonCommercial-ShareAlike 2.5 Canada
http://creativecommons.org/licenses/by-nc-sa/2.5/ca/
*/
using System.Diagnostics;
//using System.Data;
using System.Collections;
using System.Collections.Generic;
using System;
using System.ComponentModel;



namespace xGameConsoleXNA
{
	namespace GenericCommands
	{
		
		public class SimpleScripting : BaseCommands
		{
			
			
			public class Script : IDisposable
			{
				
				
				protected internal System.Collections.Specialized.StringCollection mobjLines = new System.Collections.Specialized.StringCollection();
				protected internal int mintCurrentLine = - 1;
				protected internal Stack<int> mobjLoops = new Stack<int>();
				
				
				
				public virtual string Execute(CommandManager Manager)
				{
					//Manager.AddCommand("beginloop", AddressOf BeginLoop)
					//Manager.AddCommand("endloop", AddressOf EndLoop)
					//Manager.AddCommand("exitloop", AddressOf ExitLoop)
					
					while (true)
					{
						mintCurrentLine++;
						if (mintCurrentLine > mobjLines.Count - 1)
						{
							mintCurrentLine = 0;
							break;
						}
						
						try
						{
							string Line;
							Line = mobjLines[mintCurrentLine];
							
							// If Line.Trim.ToLower = "beginloop" Then
							//  mobjLoops.Push(mintCurrentLine)
							
							//If Line.Trim.ToLower = "endloop" Then
							//    Dim Index As Integer
							//    Index = mobjLoops.Pop()
							//    mintCurrentLine = Index
							//    Line = mobjLines(mintCurrentLine)
							//    Me.Execute(Manager)
							
							//ElseIf Line.Trim.ToLower = "exitloop" Then
							//    For idx As Integer = mintCurrentLine To mobjLines.Count - 1
							//        If mobjLines(idx).Trim.ToLower = "endloop" Then
							//            mintCurrentLine = idx
							//            Exit For
							//        End If
							//    Next
							//    Me.Execute(Manager)
							//    'Else
							//End If
							Manager.Execute(Line, null);
							
						}
						catch (Exception)
						{
							//   Return Nothing
						}
					}
					
					//Manager.RemoveCommand("beginloop")
					//Manager.RemoveCommand("endloop")
					//Manager.RemoveCommand("exitloop")
					
					return null;
				}
				
				#region " IDisposable Support "
				private bool disposed = false;
				
				// IDisposable
				private void Dispose(bool disposing)
				{
					if (! this.disposed)
					{
						if (disposing)
						{
							mobjLines.Clear();
							mobjLines = null;
							mobjLoops.Clear();
							mobjLoops = null;
						}
						
						// put code to free unmanaged resources here
					}
					this.disposed = true;
				}
				
				// This code added by Visual Basic to correctly implement the disposable pattern.
				public virtual void Dispose()
				{
					// Do not change this code.  Put cleanup code in Dispose(ByVal disposing As Boolean) above.
					Dispose(true);
					GC.SuppressFinalize(this);
				}
				
				~Script()
				{
					// Do not change this code.  Put cleanup code in Dispose(ByVal disposing As Boolean) above.
					Dispose(false);
					//base.Finalize();
				}
				#endregion
				
			}
			
			protected internal System.Collections.Generic.Dictionary<string, Script> mobjScripts = new System.Collections.Generic.Dictionary<string, Script>();
			protected internal Script mobjExecutingScript;
			
			public SimpleScripting()
			{
			}
			
			public SimpleScripting(xGameConsoleXNA.Console Console) : base(Console)
			{
			}
			
			public override void Dispose()
			{
				base.Dispose();
				foreach (string Scr in mobjScripts.Keys)
				{
					mobjScripts[Scr].Dispose();
				}
				mobjScripts.Clear();
				mobjScripts = null;
			}
			
			#region " Commands ... "
			[Category("Scripting"), Description("Begins a loop."), VisibleToUsers(false)]public string BeginLoop(string[] args)
			{
				if (mobjExecutingScript == null)
				{
					return null;
				}
				mobjExecutingScript.mobjLoops.Push(mobjExecutingScript.mintCurrentLine - 1);
				//If mblnIsConnected And mobjManager IsNot Nothing Then
				//    If args Is Nothing Then Return Nothing
				//    If args.Length <> 1 Then Return Nothing
				//    ' process any functions that may be used for arguments
				//    args = mobjManager.ProcessArguments(args)
				
				//    If mobjScripts.ContainsKey(args(0)) Then
				//        Return mobjScripts(args(0)).Execute(mobjManager)
				//    End If
				//End If
				
				return null;
			}
			
			[Category("Scripting"), Description("Definds the end of a loop."), VisibleToUsers(false)]public string EndLoop(string[] args)
			{
				//Dim Index As Integer
				//Index = mobjLoops.Pop()
				// mintCurrentLine = Index
				if (mobjExecutingScript == null)
				{
					return null;
				}
				mobjExecutingScript.mintCurrentLine = mobjExecutingScript.mobjLoops.Pop();
				// Line = mobjLines(mintCurrentLine)
				// Me.Execute(Manager)
				//If mblnIsConnected And mobjManager IsNot Nothing Then
				//    If args Is Nothing Then Return Nothing
				//    If args.Length <> 1 Then Return Nothing
				//    ' process any functions that may be used for arguments
				//    args = mobjManager.ProcessArguments(args)
				
				//    If mobjScripts.ContainsKey(args(0)) Then
				//        Return mobjScripts(args(0)).Execute(mobjManager)
				//    End If
				//End If
				
				return null;
			}
			
			[Category("Scripting"), Description("Exits a loop."), VisibleToUsers(false)]public string ExitLoop(string[] args)
			{
				//If mblnIsConnected And mobjManager IsNot Nothing Then
				//    If args Is Nothing Then Return Nothing
				//    If args.Length <> 1 Then Return Nothing
				//    ' process any functions that may be used for arguments
				//    args = mobjManager.ProcessArguments(args)
				
				//    If mobjScripts.ContainsKey(args(0)) Then
				//        Return mobjScripts(args(0)).Execute(mobjManager)
				//    End If
				//End If
				if (mobjExecutingScript == null)
				{
					return null;
				}
				for (int idx = mobjExecutingScript.mintCurrentLine; idx <= mobjExecutingScript.mobjLines.Count - 1; idx++)
				{
					if (mobjExecutingScript.mobjLines[idx].Trim().ToLower() == "endloop")
					{
						mobjExecutingScript.mintCurrentLine = idx;
						return null;
					}
				}
				mobjExecutingScript.mintCurrentLine = mobjExecutingScript.mobjLines.Count;
				return null;
			}
			
			[Category("Scripting"), Description("Lists the loaded scripts.")]private string ListScripts(string[] args)
			{
				if (mblnIsConnected && (mobjManager != null))
				{
					
					// Dim Commands() As String
					// Commands = mobjManager.GetCommandList
					
					this.PrintBlankLine();
					this.Print("Scripts");
					this.Print("---------------");
					
					// Dim Tmp As String = ""
					// If args Is Nothing = False Then
					//If args.Length <> 0 Then Tmp = args(0).ToLower.Trim
					//  End If
					
					//Select Case Tmp
					//    Case "/w"
					//        Me.Print("""/w"" param not yet implemented")
					
					//    Case Else
					//        ' mobjExtenderManager.Console.Print(Commands)
					
					foreach (string Tmp in mobjScripts.Keys)
					{
						this.Print(Tmp);
						//Dim cd As String
						//cd = GetDescription(Tmp)
						//If cd.IndexOf(vbCrLf) <> -1 Then
						//    cd = cd.Replace(vbCrLf, vbCr)
						//    Dim Parts() As String
						//    Parts = cd.Split(vbCr.ToCharArray)
						//    Me.Print(Tmp & Space(Math.Max(20, Tmp.Length) - Math.Min(20, Tmp.Length)) & Parts(0))
						//    Dim idx As Integer
						//    For idx = 1 To Parts.Length - 1
						//        Me.Print(Space(20) & Parts(idx))
						//    Next
						//Else
						//    Me.Print(Tmp & Space(Math.Max(20, Tmp.Length) - Math.Min(20, Tmp.Length)) & cd)
						//End If
					}
					// End Select
					
					this.PrintBlankLine();
					if (mobjScripts.Count == 1)
					{
						this.Print(mobjScripts.Count.ToString() + " script.");
					}
					else
					{
						this.Print(mobjScripts.Count.ToString() + " scripts.");
					}
				}
				
				return null;
			}
			
			[Category("Scripting"), Description("Executes a script.")]static Script ExecuteScript_Old = null;
			public string ExecuteScript(string[] args)
			{
				if (mblnIsConnected && (mobjManager != null))
				{
					if (args == null)
					{
						return null;
					}
					if (args.Length != 1)
					{
						return null;
					}
					// process any functions that may be used for arguments
					args = mobjManager.ProcessArguments(args);
					
					if (mobjScripts.ContainsKey(args[0]))
					{
						ExecuteScript_Old = mobjExecutingScript;
						mobjExecutingScript = mobjScripts[args[0]];
						mobjExecutingScript.Execute(mobjManager);
						mobjExecutingScript = ExecuteScript_Old;
					}
				}
				
				return null;
			}
			
			[Category("Scripting"), Description("Removes a script.")]public string RemoveScript(string[] args)
			{
				if (mblnIsConnected && (mobjManager != null))
				{
					if (args == null)
					{
						return null;
					}
					if (args.Length != 1)
					{
						return null;
					}
					// process any functions that may be used for arguments
					args = mobjManager.ProcessArguments(args);
					
					if (mobjScripts.ContainsKey(args[0]))
					{
						mobjScripts.Remove(args[0]);
						return "True";
					}
					else
					{
						return "False";
					}
				}
				return null;
			}
			
			[Category("Scripting"), Description("Loads a script from a file.")]public string LoadScript(string[] args)
			{
				if (mblnIsConnected && (mobjManager != null))
				{
					
					if (args == null)
					{
						return null;
					}
					if (args.Length != 2)
					{
						return null;
					}
					// process any functions that may be used for arguments
					args = mobjManager.ProcessArguments(args);
					
					// check if script with that name already exists
					if (mobjScripts.ContainsKey(args[0]))
					{
						return null;
					}
					
					// get file name for script file
					string File;
					File = Helpers.StringArrayToString(args, 1, ' ');
					
					// check if script file exists or not
					if (System.IO.File.Exists(File) == false)
					{
						return null;
					}
					
					// create a new script
					Script Scr = new Script();
					
					// everything seems ok so we load script
					System.IO.StreamReader F = null;
					F = new System.IO.StreamReader(File);
					while (F.Peek() != - 1)
					{
						string Tmp;
						Tmp = F.ReadLine();
						// do not add comments (standard vb style or C style language comments) or blank lines
						if (Tmp.Trim() != "" && Tmp.Trim().StartsWith("\'") == false && Tmp.Trim().ToLower().StartsWith("rem") == false && Tmp.Trim().ToLower().StartsWith("//") == false)
						{
							Scr.mobjLines.Add(Tmp);
						}
					}
					F.Close();
					F = null;
					
					//Dim Data As String
					//Data = My.Computer.FileSystem.ReadAllText(File)
					//Scr.mobjLines.AddRange(Data.Split(New String() {vbCrLf}, StringSplitOptions.RemoveEmptyEntries))
					//Dim idx As Integer
					//While idx < Scr.mobjLines.Count
					//    Dim Tmp As String
					//    Tmp = Scr.mobjLines(idx).Trim
					//    ' do not add comments (standard vb style or C style language comments) or blank lines
					//    If Tmp = String.Empty Or Tmp.StartsWith("'") = False Or Tmp.ToLower.StartsWith("rem") = False _
					//       Or Tmp.StartsWith("//") = False Then
					//        Scr.mobjLines.RemoveAt(idx)
					//    Else
					//        idx += 1
					//    End If
					//End While
					
					// add script
					mobjScripts.Add(args[0].Trim(), Scr);
				}
				// do not return anything
				return null;
			}
			#endregion
			
			public override void OnConnect(CommandManager Manager, CommandExtenderManager ExtenderManager)
			{
				base.OnConnect(Manager, ExtenderManager);
				if (mobjManager == null)
				{
					return;
				}
				//mobjManager = Manager
				//If mobjManager Is Nothing Then Exit Sub
				//If mobjManager.Console Is Nothing Then Exit Sub
				//If mobjManager.Console.CommandManager Is Nothing Then Exit Sub
				//mobjCommandList = New Collections.Specialized.StringCollection()
				//AddHandler mobjManager.Console.CommandManager.BeforeRemoveCommand, AddressOf CommandIsBeingRemoved
				//mblnIsConnected = True
				DoAddCommand("loadscript", new xGameConsoleXNA.CommandCallback( LoadScript));
				DoAddCommand("removescript", new xGameConsoleXNA.CommandCallback( RemoveScript));
				DoAddCommand("listscripts", new xGameConsoleXNA.CommandCallback( ListScripts));
				DoAddCommand("executescript", new xGameConsoleXNA.CommandCallback( ExecuteScript));
				DoAddCommand("beginloop", new xGameConsoleXNA.CommandCallback( BeginLoop));
				DoAddCommand("endloop", new xGameConsoleXNA.CommandCallback( EndLoop));
				DoAddCommand("exitloop", new xGameConsoleXNA.CommandCallback( ExitLoop));
				
			}
		}
	}
}
