/*
Created by: X
http://www.createdbyx.com/

xGameConsoleXNA is licenced under the Creative Commons Attribution-NonCommercial-ShareAlike 2.5 Canada
http://creativecommons.org/licenses/by-nc-sa/2.5/ca/
*/
// Special thanks to Jason Olson from which this code is based on.
// http://geekswithblogs.net/jolson/
// http://geekswithblogs.net/jolson/archive/2004/02/16/2174.aspx
using System.Diagnostics;
//using System.Data;
using System.Collections;
using System.Collections.Generic;
using System;


namespace xGameConsoleXNA
{
	public class CommandBuffer : IDisposable
	{
		
		
		// Attributes/Properties
		private Queue mobjLines = new Queue();
		
		public Queue Lines
		{
			get
			{
				return mobjLines;
			}
		}
		
		public CommandBuffer()
		{
		}
		
		public void AddLine(string text)
		{
			mobjLines.Enqueue(text);
		}
		
		public void AddLine(string[] text)
		{
			foreach (string Tmp in text)
			{
				mobjLines.Enqueue(Tmp);
			}
		}
		
		public void AddLine(System.Collections.Specialized.StringCollection text)
		{
			foreach (string Tmp in text)
			{
				mobjLines.Enqueue(Tmp);
			}
		}
		
		#region " IDisposable Support "
		private bool disposedValue = false; // To detect redundant calls
		
		// IDisposable
		protected virtual void Dispose(bool disposing)
		{
			if (! this.disposedValue)
			{
				if (disposing)
				{
					// free unmanaged resources when explicitly called
					mobjLines.Clear();
					mobjLines = null;
				}
				
				// free shared unmanaged resources
			}
			this.disposedValue = true;
		}
		
		// This code added by Visual Basic to correctly implement the disposable pattern.
		public void Dispose()
		{
			// Do not change this code.  Put cleanup code in Dispose(ByVal disposing As Boolean) above.
			Dispose(true);
			GC.SuppressFinalize(this);
		}
		#endregion
		
	}
}
